<?php


// Check the gallery


// === Functions

/*
function file_get_contents($filename, $use_include_path = 0) {
$fd = fopen ($filename, "rb", $use_include_path);
$contents = fread($fd, filesize($filename));
fclose($fd);
return $contents;
};
*/

function logstr($string)
{
  global $log_file, $log_maxline;

  $fd = fopen ($log_file, "a+b");
  fwrite($fd,$string . "\n");
  fclose($fd);

};

function keep_clean()
{

  global $thumb_dir, $base_rep, $resolution, $cache_size, $cache_path;
  // This function must launch cleaning checkup once every 20 times
  // we use a random fonction

  $base=basename(dirname("$base_rep/test"));

  $rand_nb=rand(1,50);

  if ($rand_nb == "1")
    {
      //      logstr("Cleaning of cached files");
      if (is_dir("$tmp_web_path/$base"))
      {
	
	$cached_files=explode("\n",trim(`cd "$tmp_web_path/$base"; find ./ -type f -iname \*.jpg | sed 's/\\.\///g'`));

	$existing_files=explode("\n",trim(`cd "$base_rep"; find ./ -type f -iname \*.jpg | sed 's/\\.\///g'`));

	reset($existing_files);
	while (list ($key, $val) = each ($existing_files))
	  {
	    
	    $dir_img = dirname($val) . "/";
	    if ($dir_img == "./")
	      $dir_img = "";


	    $basename_img = current(split("\.",basename($val)));
	    $extname_img = next(split("\.",basename($val)));
	    
	    reset($resolution);
	    while (list ($k1, $v1) = each ($resolution))
	      {
		$filename="$dir_img" . $basename_img . "-" . $k1 . "." . $extname_img;
		if (in_array($filename,$cached_files)) 
		  {
		    $result = array_search($filename,$cached_files);
		    $cached_files[$result] = "";
		  };
	      };
    
	  };

	reset($cached_files);
	while (list ($key, $val) = each ($cached_files))
	  {
	    if ($val != "")
	      {
		logstr("  - deleted '$tmp_web_path/$base/$val'");
		unlink("$tmp_web_path/$base/$val");
	      };
	  };


	return(0);
      };
    };
 
  if ($rand_nb == "2")
    {

      // logstr("Cleaning of cached directory");
     
      if (is_dir("$tmp_web_path/$base"))
	{

	  $cached_dirs=explode("\n",trim(`cd "$tmp_web_path/$base"; find ./ -type d | sed 's/\\.\///g' `));
	  
	  reset($cached_dirs);
	  while (list ($key, $val) = each ($cached_dirs))
	    {
	      if ((!is_dir("$base_rep/$val")) && (is_dir("$tmp_web_path/$base/$val")))
		{
		  logstr(" - deleted directory '$tmp_web_path/$base/$val'");
		  system("rm -rf \"$tmp_web_path/$base/$val\"");
		};
	    };
	};

      return(0);
    };

  if ($rand_nb == "3")
    {

      //logstr("Cache size manager started");

      $md5_files=explode("\n",trim(`cd "$cache_path"; find ./ -type f -iname \*.jpg -maxdepth 1 | sed 's/\\.\///g' | ls -tc`));
      
      //var_dump($md5_files);

      $totalsize = 0;
      reset($md5_files);
      while (list ($key, $val) = each ($md5_files))
	{
	  $totalsize = $totalsize + (filesize("$cache_path/$val")/1024);
	  if ($totalsize <= ($cache_size * 1024))
	    $md5_files["$key"] = "";
	};

      reset($md5_files);
      while (list ($key, $val) = each ($md5_files))
	{
	    if ($val != "")
	      {
		logstr("  - deleting '$cache_path/$val'");
		unlink("$cache_path/$val");
	      };
	};

      return(0);
    };
};

//keep_clean();
//exit(1);
// === Check arguments

if (isset($_REQUEST['debug']))
{
  $debug=true;
  echo "DEBUG";
};

if ((array_key_exists('gallery',$_REQUEST)) && (is_dir("$base_rep/$gallery")))
{
  $gallery=$_REQUEST['gallery'];
}
else
{
  header("Content-type: image/jpeg");
  $src_img=ImageCreateFromjpeg("$icon_path/nogallery.jpg");
  imagejpeg($src_img);
  exit(0);
}

if (array_key_exists('img',$_REQUEST))
{
  $image = $_REQUEST['img'];
}
else
{
  // In here, we must display a Thumb for a Gallery

  // Must construct a uniq name for thumb of galleries
  //  it must depends on :
  //    x - the existence/content of the  "third line of file desc.nfo" 
  //          chosen image...

  if ( $gallery == "")
    {
      $gallery_rep="$base_rep";
      $shadow_rep="$tmp_web_dir/$base";
    }
  else
    {
      $gallery_rep="$base_rep/$gallery";
      $shadow_rep="$tmp_web_dir/$base/$gallery";
    };

  $img="";
 
  if (file_exists("$gallery_rep/desc.nfo"))
    {
      $img=trim(`cat "$gallery_rep/desc.nfo" | tail +3 | head -1`);
      if ($img != "")
	$img =  "$gallery_rep/" . $img;
    };

  //  echo "desc.nfo: $img<BR>";

  if (($img == "") || (!file_exists($img)))
    {
      $img = trim(`ls "$gallery_rep/" -1A | grep -i \\.jpg\$ | head -1`);
      if ($img != "")
	$img =  "$gallery_rep/" . $img;
    };

  // echo "first of dir: $img<BR>";

  if (($img == "") || (!file_exists($img)))
    {
      $img = "$icon_path/gallery-nophoto.jpg";
    };

  //  echo "no-photo: $img<BR>";

  
  $uniq_name=md5(file_get_contents($img));

  $thumb="$cache_path/ico-gal-" . $uniq_name . ".jpg";

  if (!file_exists($thumb))
  {
    // echo "$img<BR>";
    $resol_base=getimagesize($img);
  
    $sizeX=$resol_base[0];
    $sizeY=$resol_base[1];

    $factor = 83 / $sizeX;

    $new_w=round($factor * $sizeX);
    $new_h=round($factor * $sizeY);
 
    if ($new_h > 77)
    {
        $factor = 77 / $sizeY;
	
	$new_w=round($factor * $sizeX);
	$new_h=round($factor * $sizeY);
    };

    $offsetX=6;
    $offsetY=11;

    $offsetX += (83 - $new_w)/2;
    $offsetY += (77 - $new_h)/2;

    $temp_file="$tmp_path/tmp-" . md5(uniqid(getmypid()))  . ".jpg";
    $resol=$new_w. 'x' . $new_h ;

    // TODO : check all is going well...

    system('/usr/local/bin/convert -size ' . $resol . " \"" . $img . '" -resize ' .$resol . ' +profile "*" "' . $temp_file . '"');

    system('/usr/local/bin/composite -geometry +' . $offsetX . '+' . $offsetY .  ' ' . 
           "\"$temp_file\" " . 
           "\"$icon_path/gallery.jpg\" " . 
           "\"$thumb\"" );
    system('rm "' . $temp_file . '"');

  }
  else
  {
    keep_clean();
  };

  if (file_exists($thumb))
  {
    header("Content-type: image/jpeg");
    $src_img=ImageCreateFromjpeg($thumb);
    imagejpeg($src_img);
    exit(0);
  };

  if ($debug) 
    {
      echo "Unexpected !!! Created image but '$thumb' doesn't exists.";
      exit(1);
    };

  header("Content-type: image/jpeg");
  $src_img=ImageCreateFromjpeg("$icon_path/unexpected.jpg");
  imagejpeg($src_img);
  exit(0);

}


if (!file_exists("$base_rep/$gallery/" . $image))
{
  header("Content-type: image/jpeg");
  $src_img=ImageCreateFromjpeg("$icon_path/inexistence.jpg");
  imagejpeg($src_img);
  exit(0);
};

// Must construct a uniq name for thumb of image
//  it must depends on :
//    x - the existence/content of the  "third line of file desc.nfo" 
//          chosen image...

$uniq_name=md5(file_get_contents("$base_rep/$gallery/$image"));
$thumb="$cache_path/ico-img-" . $uniq_name . ".jpg";

// Create thumbnail if not already existent

if (!file_exists($thumb))
{

//    $resol_base=explode("x", `/usr/local/bin/identify "$base_rep/$gallery/$image" | cut --field=3 --delimiter=" " | sed s/+.*//`);

    $resol_base=getimagesize("$base_rep/$gallery/$image");
  
    $sizeX=$resol_base[0];
    $sizeY=$resol_base[1];

    $new_w=round(($Percent * $sizeX)/100);
    $new_h=round(($Percent * $sizeY)/100);
 
    $max=max($new_w,$new_h);
    $min=min($new_w,$new_h);

    if (($min < $SquareMin) && ($max < $SquareMax))
    {
	$new_w=round(($new_w * $SquareMin)/$min);
	$new_h=round(($new_h * $SquareMin)/$min);
    };

    if ($max > $SquareMax)
    {
	$new_w=round(($new_w * $SquareMax)/$max);
	$new_h=round(($new_h * $SquareMax)/$max);
    };

    $resol=$new_w. 'x' . $new_h ;

    system('/usr/local/bin/convert -size ' . $resol . " \"$base_rep/$gallery/" . $image . '" -resize ' .$resol . ' +profile "*" "' . $thumb . '"');

}
else
{
  keep_clean();
};

if (file_exists($thumb))
{
  header("Content-type: image/jpeg");
  $src_img=ImageCreateFromjpeg($thumb);
  imagejpeg($src_img);
  exit(0);
};


header("Content-type: image/jpeg");
$src_img=ImageCreateFromjpeg("$icon_path/unexpected.jpg");
imagejpeg($src_img);
exit(0);


?>
